﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MesDataUpload.Core.Model
{
    /// <summary>
    /// LC 与 DB 类的映射关系， 会在程序入口处， 手动使用 
    /// var assemblies = System.AppDomain.CurrentDomain.GetAssemblies();
    /// var cfg = new MapperConfigurationExpression();
    /// cfg.AddMaps(assemblies);
    /// Mapper.Initialize(cfg);
    /// 
    /// 枚举全部程序集 中的AutoMapper.Profile 全部加载！！！
    /// </summary>
    public class Lc_AutoMapperProfile : AutoMapper.Profile
    {
        public static AutoMapper.IMapper Mapper;
        static Lc_AutoMapperProfile()
        {
            var cfg = new AutoMapper.Configuration.MapperConfigurationExpression();
            cfg.AddProfile<Lc_AutoMapperProfile>();
            AutoMapper.MapperConfiguration config = new AutoMapper.MapperConfiguration(cfg);
            Mapper = new AutoMapper.Mapper(config);
        }

        public Lc_AutoMapperProfile()
        {
            #region Lc_SampleData
            CreateMap<Lc_SampleData, Db_SampleData>().ForMember(s => s.SampleADs, opt =>
            {
                opt.MapFrom(s => Newtonsoft.Json.JsonConvert.SerializeObject(s.SampleADs));
            }).ReverseMap().ForMember(s => s.SampleADs, opt =>
            {
                opt.MapFrom(s => Newtonsoft.Json.JsonConvert.DeserializeObject<int[]>(s.SampleADs));
            });
            #endregion

            #region Lc_ScanData
            CreateMap<Lc_ScanData, Db_ScanData>().ForMember(s => s.Datas, opt =>
            {
                opt.MapFrom(s => Newtonsoft.Json.JsonConvert.SerializeObject(s.Datas));
            }).ReverseMap().ForMember(s => s.Datas, opt =>
            {
                opt.MapFrom(s => Newtonsoft.Json.JsonConvert.DeserializeObject<double[]>(s.Datas));
            });
            #endregion
        }


    }
}
