﻿using GalaSoft.MvvmLight.Command;
using MahApps.Metro.Controls;
using MahApps.Metro.Controls.Dialogs;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace MesDataUpload
{
    public class WdSettingVm : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public string Dept { get; set; }

        /// <summary>
        /// 设备编号
        /// </summary>
        public string Sbbh { get; set; } = "JQ02-1012";

        /// <summary>
        /// 是负极
        /// </summary>
        public bool IsFj { get; set; } 

        public RelayCommand OKCmd { get; private set; }

        Core.Upload upload;
        MetroWindow metroWindow;
        public void Init(MetroWindow metroWindow)
        {
            InitCmd();
            this.metroWindow = metroWindow;
            upload = Core.Upload.Instance;
            var param = upload.Param;
            Dept = param.Dept;
            Sbbh = param.Sbbh;
            IsFj = param.Zfj == "负极";
        }
        void InitCmd()
        {
            OKCmd = new RelayCommand(OK);
        }
        async void OK()
        {
            var param = upload.Param;
            param.Dept = Dept;
            param.Sbbh = Sbbh;
            if (IsFj)
            {
                param.Zfj = "负极";
            }
            else
            {
                param.Zfj = "正极";
            }
            if (upload.Save())
            {
                await metroWindow.ShowMessageAsync("",$"设置成功");
                return;
            }
            else
            {
                await metroWindow.ShowMessageAsync("", $"设置失败");
                return;
            }
        }
    }
}
